#include <Arduino.h>
#include <avr/io.h>
#include <util/delay.h>

const int BUTTON=0;
const int GREEN_LED=1;
const int RED_LED=2;

class ledPattern{

  private:
  volatile int ledPatternState=0;

  public:
  void nextPattern();
  volatile int getPattern();
};

void buttonPress();
void sirenPattern();
void greenPattern();
void redPattern();
void doublePattern();


void setup() {
  pinMode(BUTTON,INPUT_PULLUP);
  attachInterrupt(BUTTON,buttonPress,RISING);
  pinMode(GREEN_LED,OUTPUT);
  pinMode(RED_LED,OUTPUT);
}


ledPattern ledPat;
int ledState=0;
void loop() {
  switch (ledPat.getPattern())
  {
  case 0:
    sirenPattern();
    break;

  case 1:
    greenPattern();
    break;

  case 2:
    redPattern();
    break;

  case 3:
    doublePattern();
    break;
  }
}

volatile int ledPattern::getPattern(){
  return ledPatternState;
}

void ledPattern::nextPattern(){
  if (ledPatternState !=3){
    ledPatternState++;
  }else{
    ledPatternState=0;
  }
}

void buttonPress(){
  static unsigned long last_interrupt_time = 0;
  unsigned long interrupt_time = millis();
  if (interrupt_time - last_interrupt_time > 200){
    ledPat.nextPattern();
  }
  last_interrupt_time = interrupt_time;
}

void sirenPattern(){
  if (ledState==0){
    digitalWrite(RED_LED,HIGH);
    digitalWrite(GREEN_LED,LOW);
    ledState=1;
  }else{
    digitalWrite(GREEN_LED,HIGH);
    digitalWrite(RED_LED,LOW);
    ledState=0;
  }
  delay(500);
}


void doublePattern(){
  if (ledState==0){
    digitalWrite(RED_LED,HIGH);
    digitalWrite(GREEN_LED,HIGH);
    ledState=1;
  }else{
    digitalWrite(GREEN_LED,LOW);
    digitalWrite(RED_LED,LOW);
    ledState=0;
  }
  delay(500);
}

void greenPattern(){
    if (ledState==0){
    digitalWrite(RED_LED,LOW);
    digitalWrite(GREEN_LED,HIGH);
    ledState=1;
  }else{
    digitalWrite(GREEN_LED,LOW);
    digitalWrite(RED_LED,LOW);
    ledState=0;
  }
  delay(500);
}


void redPattern(){
    if (ledState==0){
    digitalWrite(RED_LED,HIGH);
    digitalWrite(GREEN_LED,LOW);
    ledState=1;
  }else{
    digitalWrite(GREEN_LED,LOW);
    digitalWrite(RED_LED,LOW);
    ledState=0;
  }
  delay(500);
}